/* Klas linklist perprogramuokite taip, kad ji bt ablonin klas Tlinklist. Tlinklist klas turi bti tokia,
  kad jos objektuose  konteineriuose  galima saugoti tik objekt/kintamj adresus.
   Sukurkite du Tlinklist klass egzempliorius  sraus : vien, kuris yra skirtas saugoti string objektus, ir kit,
    kuris yra skirtas saugoti geometrins figros objektus*. Abu sraus upildykite rodyklmis 
     dinaminje atmintyje sukurtus atitinkamus objektus.*/
#include <iostream>

using namespace std;

template <class T> 
class linklist
{
     private:
          struct node
         {
              T data;
            node *link;
         }*p;

   public:

             linklist();
         void append( T num );
         void add_as_first( T num );
         void addafter_index( int index, T num );
         void del( T num );
			int get_at_index(int index);
         int count();
			node* get_last_node();
         ~linklist();
};
template <class T>
linklist<T>::linklist()
{
     p=NULL;
}
template <class T>
void linklist<T>::append(T num)
{
     node *q,*t;
   if( p == NULL )
   {
        p = new node;
      p->data = num;
      p->link = NULL;
   }
   else
   {
        q = p;
      while( q->link != NULL )
           q = q->link;

      t = new node;
      t->data = num;
      t->link = NULL;
      q->link = t;
   }
}
template <class T>
void linklist<T>::add_as_first(T num)
{
     node *q;

   q = new node;
   q->data = num;
   q->link = p;
   p = q;
}
template <class T>
void linklist<T>::addafter_index( int index, T num)
{
     node *q,*t;
   int i;
   for(i=0,q=p;i<index;i++)
   {
        q = q->link;
      if( q == NULL )
      {
           cout<<"\nThere are less than "<<index<<" elements.";
         return;
      }
   }

   t = new node;
   t->data = num;
   t->link = q->link;
   q->link = t;
}
template <class T>
void linklist<T>::del( T num )
{
     node *q,*r;
   q = p;
   if( q->data == num )
   {
        p = q->link;
      delete q;
      return;
   }

   r = q;
   while( q!=NULL )
   {
        if( q->data == num )
      {
           r->link = q->link;
         delete q;
         return;
      }

      r = q;
      q = q->link;
   }
   cout<<"\nNot Deleted: Element Not Found.";
}
template <class T>
int linklist<T>::get_at_index(int index)
{
     node *q = p;
	  int current_index = 0;
		while (current_index != index) {
			q = q->link;
			++current_index;
		}		
		return q->data;
}

template <class T>
int linklist<T>::count()
{
     node *q;
   int c=0;
   for( q=p ; q != NULL ; q = q->link )                                                                                                                                                                                                 
        c++;

   return c;
}
template <class T>
linklist<T>::~linklist()
{
     node *q;
   if( p == NULL )                                                                                                                                                                                                                                                  
        return;

   while( p != NULL )
   {
        q = p->link;
      delete p;
      p = q;
   }
}

int main()
{
     linklist<int> ll;
   cout<<"No. of elements = "<<ll.count();
   ll.append(12);
   ll.append(13);
   ll.append(23);
   ll.append(43);
   ll.append(44);
   ll.append(50);

   ll.add_as_first(2);
   ll.add_as_first(1);
	cout << "\nat 0: " << ll.get_at_index(0) << endl;
	cout << "\nat 2: " << ll.get_at_index(2) << endl;

   ll.addafter_index(3,333);
   ll.addafter_index(6,666);

   cout<<"\nNo. of elements = "<<ll.count();
	cout << "\nat 9: " << ll.get_at_index(9) << endl;

   ll.del(333);
   ll.del(12);
   ll.del(98);
   cout<<"\nNo. of elements = "<<ll.count()<<endl<<endl;
system ("PAUSE");
}
